'use strict';

exports.__esModule = true;

var _lodash = require('lodash.isplainobject');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function forEachObject(obj, fn, path) {
    for (var key in obj) {
        var deepPath = path ? path + '.' + key : key;

        // Note that we always use obj[key] because it might be mutated by forEach
        fn.call(obj, obj[key], key, obj, deepPath);

        forEach(obj[key], fn, deepPath);
    }
}

function forEachArray(array, fn, path) {
    array.forEach(function (value, index, arr) {
        var deepPath = path + '[' + index + ']';

        fn.call(arr, value, index, arr, deepPath);

        // Note that we use arr[index] because it might be mutated by forEach
        forEach(arr[index], fn, deepPath);
    });
}

function forEach(value, fn, path) {
    path = path || '';

    if (Array.isArray(value)) {
        forEachArray(value, fn, path);
    } else if ((0, _lodash2.default)(value)) {
        forEachObject(value, fn, path);
    }
}

exports.default = forEach;
module.exports = exports['default'];